library LazHttpsGF;

{$mode objfpc}{$H+}

uses
  { you can add units after this }
  Classes, Windows, LazUTF8, IdHTTP, IdSSLOpenSSL, IdGlobal;

//Project Options 路徑之 Othet unit files 加入以下路徑:
//C:\lazarus\components\lazutils\lib\i386-win32\
//C:\lazarus\_VCL\INDY_10_6_2\Lib\lib\i386-win32\  //我 lazarus INDY 安裝位置 C:\lazarus\_VCL\INDY_10_6_2\


//---------------------------------------------------------------------------
//內部使用函式-取出 dll 路徑(utf8)
function GetModuleName: string;
var
  szFileName: array[0..MAX_PATH] of Char;
begin
  FillChar(szFileName, SizeOf(szFileName), #0);
  GetModuleFileName(hInstance, szFileName, MAX_PATH); //uses Windows
  Result := WinCPToUTF8(szFileName);
end;

//===========================================================================
//以下為外部程式使用函式 (最後面要 exports 出去)
//===========================================================================
function HttpsGetFile(str_https_url: pchar; str_dl_fname: pchar): integer; stdcall;
var rv: Integer; //result 值
    IdHTTP1: TIdHTTP;
    IdSSLIOHandlerSocketOpenSSL1: TIdSSLIOHandlerSocketOpenSSL;
    fstream:TFileStream;
begin

  rv:=0; //result 值
  IdHTTP1:=TIdHTTP.Create(nil);
  IdSSLIOHandlerSocketOpenSSL1:=TIdSSLIOHandlerSocketOpenSSL.Create(nil);

  try
        //---------------------------------
        //設定通訊元件
        //---------------------------------
        IdHTTP1.HandleRedirects:=true;
        IdHTTP1.ReadTimeout:=20000;
        //IdHTTP1.Port:=8080;

        //走 https 通信協定的話 (with ssleay32.dll & libeay32.dll)
        if (true) then begin
            //IdSSLIOHandlerSocketOpenSSL1.SSLOptions.Method:=sslvSSLv3;
            IdSSLIOHandlerSocketOpenSSL1.SSLOptions.Method:=sslvTLSv1_2; //同 LinePay 要用到 TLS V1.2
            IdHTTP1.IOHandler:=IdSSLIOHandlerSocketOpenSSL1;
        end;


        fstream:=TFileStream.Create(str_dl_fname, fmCreate);
        IdHTTP1.Get(str_https_url, fstream);
        rv:=1; //當漏完成;


  finally
    IdHTTP1.Free;
    IdSSLIOHandlerSocketOpenSSL1.Free;
  end;

  result:=rv; //0:Download_NG  1:Download_OK

end;

//===========================================================================
exports HttpsGetFile;


end.

