unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private

  public

  end;


//使用 LazHttpsGF.dll 中的 HttpsGetFile() 函式
//要將 LazHttpsGF.dll & libeay32.dll & ssleay32.dll 三個 dll 檔一起放入執行檔路徑)
function HttpsGetFile(
    str_https_url: pchar;
    str_dl_fname: pchar
):integer; STDCALL; external 'LazHttpsGF.dll';


var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

//測試案例一
procedure TForm1.Button2Click(Sender: TObject);
begin
  Edit1.Text:='https://www.dropbox.com/s/715qik3sf2rygtw/test.dll?dl=1';
  Edit2.Text:='_test.dll';
end;


//測試案例二
procedure TForm1.Button3Click(Sender: TObject);
begin
  Edit1.Text:='https://www.cwb.gov.tw/rss/forecast/36_04.xml';
  Edit2.Text:='_36_04.xml';
end;

//下載
procedure TForm1.Button1Click(Sender: TObject);
var fn: string;
    r: integer;
begin
  fn:=ExtractFilePath(Application.ExeName)+Edit2.Text;

  r:=HttpsGetFile(pchar(Edit1.Text), pchar(fn));
  if (r=1) then begin
      ShowMessage(fn+' 下載成功');
  end else begin
      ShowMessage(fn+' 下載失敗');
  end;



end;

end.

